/*
 * BSD License
 *
 * Copyright (c) 2007, The University of Manchester (UK)
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *     - Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     - Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *     - Neither the name of the University of Manchester nor the names
 *       of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written
 *       permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * Implementation of a list of frontier grid cells
 *
 * @author Chris Kirham (chris@cs.manchester.ac.uk)
 * @version 1.0, 3/Oct/2007
 */

public class Frontier_List {

final static int FQSIZE = 5000;

int [][] fq;
int qback, qfront;

    Frontier_List() {
	fq = new int[FQSIZE][3];
	qback = 0;
	qfront = 0;
    }

    public void addElement(int x, int y, int z) {
        fq[qback][0] = x;
        fq[qback][1] = y;
        fq[qback][2] = z;
        qback++;
        if (qback == FQSIZE) qback = 0;
        if (qback == qfront){
            System.out.println("Frontier Queue Full");
            System.exit(30);
        }
    }

    public int[] getElement() {
	if (qfront == qback) {
	    System.out.println ("Error Frontier Queue Empty");
	    System.exit(31);
	}
	int qf = qfront;
	qfront++;
        if (qfront == FQSIZE) qfront = 0;
	return fq[qf];
    }

    public boolean isEmpty() {
      return qfront == qback;
    }
}
